# How to contribute

I'm really glad you're reading this.

## Submitting changes

Please send a [GitHub Pull Request to pboted](https://github.com/polistern/pboted/pull/new/master) with a clear list of what you've done (read more about [pull requests](http://help.github.com/pull-requests/)).

Please follow [style convention](#style-conventions) and make sure all of your commits are atomic (one feature per commit).

Always write a clear log message for your commits.

One-line messages are fine for small changes, but bigger changes should look like this:

```
$ git commit -m "A brief summary of the commit
>
> A paragraph describing what changed and its impact."
```

## Style conventions

After a short discussion, one of the [coding styles](https://github.com/motine/cppstylelineup) will be determined, which better meets our requirements.

But for now:

  * We indent using **two spaces**
  * We put spaces after:
    - list items (`[1, 2, 3]`, not `[1,2,3]`)
    - method parameters (`function (var1, var2)`, not `function(var1,var2)`)
    - around operators (`x += 1`, not `x+=1`)

For now, that's all.

If you have any questions about the code and style, you can find me in `[#dev]` channel on **ilita** IRC network in to I2P.

Sincerely yours,  
*polistern*
