# Kademlia (ЧЕРНОВИК)

Реализация распределённой хеш-таблицы, используемой в I2P-Bote, отличается от стандартной по следующим пунктам:

* Хранимые данные могут быть удалены из таблицы
* Нет кеширования хранимых данных, т.к. после получения они удаляются
* I2P-Bote использует "списки сиблингов" (S-buckets), как рекомендовано в документации к S/Kademlia

Существует 3 типа данных, которые могут быть сохраны на узлах:

* Почтовый пакет
* Индексный пакет
* Контакт

## Почтовый пакет

ToDo

## Индексный пакет

`Индексный пакет` содержит DHT-ключи одного и более `Почтовых пакетов`.  
DHT-ключ самого `Индексного пакета` является SHA-256 хэшем `Почтового назначения`, для которого предназначены письма.  
Для проверки наличия новых пактов для выбранного `Почтового назначения` узел делает запрос в DHT на наличие `Индексных пакетов` для `Почтового назначения`. Затем он делает запрос по каждому DHT-ключу `Почтовых пакетов`, которые перечислены в `Индексном пакете`.  
Когда все компоненты письма из `Индексного пакета` получены, письмо расшифровывается, восстанавливается и помещается во `Входящие`.

Для удаления `Почтового пакета` или записи из `Индексного пакета` должен быть отправлен запрос на удаление, который содержит правильную `Авторизацию Удаления`, из которой алгоритмом SHA-256 будет получен хэш `Подтверждения Удаления`.

`Авторизация Удаления` находится внутри каждой зашифрованной части письма и дополнительно используется как контрольная сумма для проверки после расшифровывания `Почтового пакета` . Это означает, что третья сторона не может удалить `Почтовый пакет`  без его расшифровки и получения `Авторизации Удаления`.

Узел, получивший запрос на удаление пакета, может перенаправлять запрос другим узлам, на случай, если они не получили подобного запроса.   

Для удаления записи из `Индексного пакета` необходима та же `Авторизация Удаления`, что и для `Почтового пакета`, которому эта запись соответствует.

## Контакт

ToDo
