# SMTP

_Работа проверена с [Mozilla Thunderbird](https://www.thunderbird.net/en-US/)_

Чтобы иметь возможность отправлять письма по протоколу SMTP Вам нужно:

- Заполнить секцию `[smtp]` в [конфигурационном файле](../user-guide/configuration.md#smtp)

```
[smtp]
enabled = true
address = 127.0.0.1
port = 9025
```

- Перезапустить **pboted** для применения настроек
- После перезапуска появится возможность подключения по SMTP порту вручную (telnet) или с помощью почтового клиента.

## Как составить письмо

### FROM

Есть два варианта того, как это поле может быть заполнено.

#### 1. Классический

В данном случае поле состоит из трёх частей:

`NAME <IDENTITY_NAME@DOMAIN>`

- `NAME` - может содержать имя доступной `Bote идентичности`
- `IDENTITY_NAME` - может содержать имя доступной `Bote идентичности`
- `DOMAIN` - может содержать любой валидный домен

Минимум одно из двух - `NAME` или `IDENTITY_NAME` - должно присутствовать в загруженных `Bote идентичностях`.  
Если оба (`NAME` и `IDENTITY_NAME`) присутствуют в загруженных `Bote идентичностях`, но относятся к разным `Bote идентичностям` - будет использована только `Bote идентичность`, указанная для `IDENTITY_NAME`.  
`DOMAIN` будет проигнорирован в любом случае.

Например:

```
John Doe <johnd@bote.i2p>
```

#### 2. Bote

В этом случае поле содержит две обязательные части:

`IDENTITY_NAME <BOTE_ADDRESS>`

- `IDENTITY_NAME` - должно содержать имя доступной `Bote идентичности`
- `BOTE_ADDRESS` - должно содержать публичную часть `Bote идентичности`

Если для `IDENTITY_NAME` будет найдена `Bote идентичность`, поле `BOTE_ADDRESS` будет заменено на значение из этой идентичности.

Например:

```
johnd <24noEIMPvV9CEwrSWQtIsTA7balaZ80ZOGRBAzrsBl5nv9xud~k28d9TQIgXmyyCYtHl8PJASAFDeefSc6EJ81>
```

### TO

Поле содержит две обязательные части:

`NAME <ALIAS>`

- `NAME` - может быть в адресной книге для успешной замены
- `ALIAS` - может быть в адресной книге для успешной замены

Одно из двух - `NAME` или `ALIAS` - должно присутствовать в адресной книге.  
Если оба (`NAME` и `ALIAS`) присутствуют в адресной книге, но относятся к разным `Почтовым назначениям` - будет использовано только `Почтовое назначение`, указанное для `ALIAS`.

Например, если в адресной книге есть запись:

```
johnd1@bote.i2p;John Doe 1;24noEIMPvV9CEwrSWQtIsTA7balaZ80ZOGRBAzrsBl5nv9xud~k28d9TQIgXmyyCYtHl8PJASAFDeefSc6EJ81
```

То Вы можете заполнить `TO` так:

`TO: John Doe <johnd1@bote.i2p>`
