# Конфигурация

Выполните `pboted --help` чтобы увидеть справку по доступным параметрам.

## Основные параметры

!!! note "Примечание"

    Параметр `service` может быть передан только как аргумент запуска.

| Параметр   | Описание                                                                                                | По умолчанию                                            |
|------------|---------------------------------------------------------------------------------------------------------|---------------------------------------------------------|
| daemon     | Процесс будет демонизирован после старта                                                                | нет                                                     |
| service    | Будет использованая системная директория для хранения файлов (например `/var/lib/pboted`)               | нет                                                     |
| conf       | Путь к файлу конфигурации. Этот параметер будет молча проигнорирован, если указаный файл не существует  | `~/.pboted/pboted.conf` или `/etc/pboted/pboted.conf`   |
| pidfile    | Путь к PID файлу                                                                                        | `~/.pboted/pboted.pid` или `/var/lib/pboted/pboted.pid` |
| log        | Как будет выводится журнал (`stdout`, `file`, `syslog`) (при демонизации `stdout`/`unspecified` может быть замещен на `file`) | `stdout`                          |
| logfile    | Путь к файлу журнала                                                                                    | автообнаружение                                         |
| loglevel   | Уровень отображения записей в журнале (`debug`, `info`, `warn`, `error`, `none`)                        | `info`                                                  |
| logclftime | Записывать дату и время в журнал в Общем Формате журнала                                                | нет                                                     |
| host       | Внешний IP для получения UDP датаграм                                                                   | `0.0.0.0`                                               |
| port       | UDP порт для получения датаграм                                                                         | `5050`                                                  |
| storage    | Лимит использования диска для хранилища (`B`, `KiB`, `MiB`, `GiB`, `TiB`)                               | `50 MiB`                                                |

## SAM

| Параметр    | Описание                                         | По умолчанию                                                      |
|-------------|--------------------------------------------------|-------------------------------------------------------------------|
| sam.name    | Имя сессии, отображаемое в SAM                   | `pboted`                                                          |
| sam.address | Адрес I2P маршрутизатора с активным SAM          | `127.0.0.1`                                                       |
| sam.tcp     | TCP порт I2P SAM                                 | `7656`                                                            |
| sam.udp     | UDP порт I2P SAM                                 | `7655`                                                            |
| sam.key     | Путь к приватному ключу для создания I2P туннеля | `~/.pboted/destination.key` или `/var/lib/pboted/destination.key` |

## Начальная загрузка

!!! note "Примечание"

    В примере конфигурационного файла уже добавлены узлы для начальной загрузки

| Параметр          | Описание                           | По умолчанию |
|-------------------|------------------------------------|--------------|
| bootstrap.address | Узлы с наибольшим временем непрерывной работы и большим списком других узлов в сети. Для запуска необходимо не менее одного другого узла с поддержкой I2P-Bote протокола версии 4 и выше. Каждая строка должна представлять из себя ключ I2P адреса назначения в формате Base64. |-|

Вы можете указать этот параметр многократно для разных адресов.  
Например:

```
[bootstrap]
address = <first address>
address = <second address>
...
address = <N-th address>
```

## SMTP

| Параметр     | Описание                                 | По умолчанию |
|--------------|------------------------------------------|--------------|
| smtp.enabled | Запустить SMTP                           | `true`       |
| smtp.address | Адрес, на котором будет доступен SMTP    | `127.0.0.1`  |
| smtp.port    | TCP порт, на котором будет доступен SMTP | `9025`       |

## POP3

| Параметр     | Описание                                 | По умолчанию |
|--------------|------------------------------------------|--------------|
| pop3.enabled | Запустить POP3                           | `true`       |
| pop3.address | Адрес, на котором будет доступен POP3    | `127.0.0.1`  |
| pop3.port    | TCP порт, на котором будет доступен POP3 | `9110`       |
